#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include <inttypes.h>

#define NMAX 28

int verbose ;

/* Definition of subtask */

typedef struct {
  int id ;
  int n ;
  int depth ;
  int seen[NMAX] ;
} subtask_t ;

subtask_t *copy_arg(subtask_t *z) ;
void free_arg(subtask_t *z) ;

void print_subtask(FILE *fp,subtask_t *z) ;
subtask_t *read_subtask(FILE *fp) ;

/* Result (unsigned 64 bits integer */
typedef uint64_t count_t ;
#define PRC PRIu64


/* Subtask generator, returns number of subtasks */
typedef void emit_t(subtask_t *z) ;
int generate_subtasks(int n, int depth, emit_t emit) ;

/* Run a subtask */
count_t run_subtask(subtask_t *z) ;

/* Run complete task */
count_t run_task(int n) ;
