#include <stdlib.h>
#include <stdio.h>
#include "poly.h"


/* Sequential computation */

static count_t sum ;

void emit_run(subtask_t *z) {
  sum += run_subtask(z) ;
}

count_t run(int n, int depth) {
  sum = 0 ;
  int ntasks = generate_subtasks(n,depth,emit_run) ;
  if (verbose) fprintf(stderr,"Subtasks: %i\n",ntasks) ;
  return sum ;
}

/* Main */
void usage(char *pgm)
{
  fprintf(stderr,"usage: %s [-v]* n\n",pgm);
  exit(-1);
}

int main (int argc, char **argv) {
  char *arg=0;
  char *pgm = argv[0];
  int n = 20 ;
  int depth = 15 ;

  while (--argc) {
    arg = *++argv;
    if (*arg == '-') {
      arg++ ;
       if (*arg == 'g') {
        if (arg[1]) {
          depth += atoi(arg+1) ;
        } else {
          usage(pgm) ;
        }
       } else if (*arg == 'v') {
         verbose++;
      } else
          usage(pgm);
    } else {
      break;
    }
  }

  if (argc >= 1) n = atoi(arg);
  if (n > NMAX) {
      fprintf(stderr,"argument must be <= %d\n",NMAX);
      exit(2);
  }
  count_t r =  run(n,depth) ;
  printf("%" PRC "\n",r) ;
  return 0 ;
}
