#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include "basic.h"


static int n = 10000 ;
static volatile int count = 0 ;
static volatile int start = 0 ;

void *f(void *p) {
  while (!start) ;
  for (int k = 0 ; k < n ; k++) count++ ;
  return NULL ;
}

void run_loose(void) {
  count = 0 ;
  start = 0 ;

  pthread_t th1,th2 ;
  create_thread(&th1,f,NULL) ;
  create_thread(&th2,f ,NULL) ;
  start = 1 ;
  (void)join_thread(&th2) ;
  (void)join_thread(&th1) ;
  printf("Loose:  %i\n",count) ;
}


static pthread_mutex_t *mutex ;

void *g(void *p) {
  while (!start) ;
  for (int k = 0 ; k < n ; k++) {
    lock_mutex(mutex) ;
    count++ ;
    unlock_mutex(mutex) ;
  }
  return NULL ;
}

void run_locked(void) {
  mutex = alloc_mutex() ;
  count = 0 ;
  start = 0 ;

  pthread_t th1,th2 ;
  create_thread(&th1,g,NULL) ;
  create_thread(&th2,g,NULL) ;
  start = 1 ;
  (void)join_thread(&th2) ;
  (void)join_thread(&th1) ;
  printf("Locked: %i\n",count) ;
}



int main (int argc, char **argv) {
  if (argc > 1) n = atoi(argv[1]) ;
  run_loose() ;
  run_locked() ;
  return 0 ;
}
