#include <stdlib.h>
#include <stdio.h>
#include "queen.h"


/* Emit argument to stdout */

void emit_stdout(subtask_t *z) { print_subtask(stdout,z) ; }  


void usage(char *pgm)
{
  fprintf(stderr,"usage: %s [-dN] [-v]* n\n",pgm);
  exit(-1);
}

int main (int argc, char **argv) {
  char *arg=0;
  int depth  = 3 ;
  char *pgm = argv[0];
  int n = 8 ;

  while (--argc) {
    arg = *++argv;
    if (*arg == '-') {
      arg++ ;
      if (*arg == 'd') {
        if (arg[1]) {
          depth = atoi(arg+1) ;
        } else {
          usage(pgm) ;
        }
      } else if (*arg == 'v') {
          verbose++;
      } else
          usage(pgm);
    } else {
      break;
    }
  }

  if (argc >= 1) n = atoi(arg);
  if (n > NMAX) {
      fprintf(stderr,"argument must be <= %zi\n",NMAX);
      exit(2);
  }
  int r = generate_subtasks(n,depth,emit_stdout) ;
  if (verbose) fprintf(stderr,"Subtasks: %i\n",r) ;
}
